#*************************************************************
# Progamm 			absorption
# Sinn des Programms: 		Berechnung der Absorption in einer homogenen Schicht
# Sinn der Einheit  :		Ausgabe
# Name der Datei    :		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		absorption_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				6
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.18
# Letzte Änderung: 		05.06.2020
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os


import matplotlib.pyplot as plt

class Ausgabe:

  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")          


  def schirm_ausgabe(self,i_max,x,Intens, Intens_analyt):
    print(i_max,"Schirmaugabe")
    for i in range(i_max):
      print (f"{i:7}", f"{x[i]:.5f}", f"{Intens[i]:.5f}",f"{Intens_analyt[i]:.5f}")

  def datei_ausgabe(self, ausgabe_datei, i_max, x, Intens, Intens_analyt, kappa, Intens_absorbiert):
    fobj_out = open(ausgabe_datei,"w")
    for i in range(i_max):
      fobj_out.write(f"{i:7}")
      fobj_out.write("\t")
      fobj_out.write(f"{x[i]:.5f}")              
      fobj_out.write("\t")
      fobj_out.write(f"{Intens[i]:.5f}") 
      fobj_out.write("\t")
      fobj_out.write(f"{Intens_analyt[i]:.5f}") 
      fobj_out.write("\n")
    fobj_out.close()
    


  def graphik_ausgabe(self,graphik_datei,i_max, x, kappa, Intens, Intens_analyt):
    titel = "Intensität bei kappa = " + str(kappa)
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    for i in range(i_max):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]
      if y_min >= Intens[i]:
        y_min = Intens[i]
      if y_max <= Intens[i]:
        y_max = Intens[i]
    #for i in range(i_max):
    plt.plot(x, Intens_analyt, 'b.',label=r'analytische Lösung')
    plt.plot(x, Intens, 'r.',label=r'numerische Lösung')
    
    
    
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title(titel)
    plt.xlabel("x [m]")
    plt.ylabel('Intensität [W/m²]')
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm als .png speichern
    plt.savefig(graphik_datei, format='png')
     # Diagramm anzeigen:
    plt.show()

